#! /usr/bin/env python

import os
import subprocess
import re
import sys

FILENAME = 'tmp.html'

if os.path.exists(FILENAME):
    os.unlink(FILENAME)

URL = 'https://www.alfortville.fr/?page=gru'
subprocess.call(['wget', '--quiet', '-O', FILENAME, '--convert-links', URL])
content = '{% load gadjo i18n static combo %}' + open(FILENAME).read().strip()
if len(content) < 500:
    sys.exit(0)

# replace action of "subscribe newsletter" form
content = content.replace('action="tmp.html"', 'action="https://www.alfortville.fr/"')

# remove tmp.html that have been added to anchor links
content = content.replace('tmp.html#', '#')

content = content.replace('</head>',
        '<title>{% firstof global_title "Mon Alfortville" %} {% block title %}{% endblock %}</title>\n</head>')

content = content.replace('</head>',
        '''
    {% if meta_robots %}
    <meta name="robots" content="{{ meta_robots }}" />
    {% elif environment_label %}
    <meta name="robots" content="noindex, nofollow, noarchive, nosnippet, notranslate, noimageindex" />
    {% endif %}

    {% block extra_top_head %}
    {% endblock %}
    {{ media }}
    <link rel="stylesheet" type="text/css" href="{{site_base}}{% static 'alfortville/style.css' %}?{% start_timestamp %}">
    {% block extra_css %}
    {% endblock %}
    {% block extra_scripts %}
    {% endblock %}
    </head>''')

content = content.replace('<body class="touch-ok">',
        r'<body {% block bodyargs %}class="touch-ok {% block bodyclasses %}{% endblock %}" {% block bodyattrs %}{% endblock %}{% endblock %}>')

content = content.replace('>Compte citoyen<', '>{{ site_title }}<')

content = content.replace('<div class="gru-content">',
        '''
<nav>
<div id="nav" class="gru-nav togglable">
{% block menu %}
  <ul>
  </ul>
{% endblock %}
</div>
</nav>

<div class="gru-content" id="content">
{% block messages %}
{% if messages %}
  <div id="messages" class="messages-login">
    <ul class="messages">
        {% for message in messages %}
        <li{% if message.tags %} class="{{ message.tags }}"{% endif %}>{{ message }}</li>
        {% endfor %}
    </ul>
  </div>
{% endif %}
{% endblock %}

            {% block content %}
            {% endblock %}
            <div style="clear: both;"></div>
''')

content = re.sub('<p>Contenu.*', '', content)

# remove breadcrumb
content = re.sub(r'<ol class="breadcrumb.*?ol>', '', content, flags=re.DOTALL)

# remove search box
content = re.sub(r'.*item-search-wp.*', '', content)

# remove favorites
content = re.sub(r'.*Mes favoris.*', '', content)

# remove copy of jquery
content = re.sub('<script src=.*jquery.min.js.*', '', content)

# remove scripts from end of page
content = re.sub(r'<script>.*/script>', '', content, flags=re.DOTALL)

# remove search scripts that requires to be run on spip
content = re.sub(r'.*liveSearch.*', '', content)
content = re.sub(r'<!-- Plugin ICDC de recherche.*?/script>', '', content,
        flags=re.DOTALL)

# remove call to google maps
content = re.sub(r'<script.*maps.google.*script>', '', content)

content = re.sub('(<a.*href=")(.*?")(.*Se connecter</a>)',
        r'''{% skeleton_extra_placeholder first-user-link %}
             {% if user.is_authenticated %}<span class="connected-user">{{user.first_name}} {{user.last_name}}</span>
             {% else %}
             <span class="login">\1{% url 'auth_login' %}" class="login-link"\3</span>
             {% endif %}
           {% end_skeleton_extra_placeholder %}''', content)

content = re.sub('(<a.*href=")(.*?)"(.*er un compte</a>)',
        r'''{% skeleton_extra_placeholder second-user-link %}
             {% if user.is_authenticated %}
             \1{% url 'auth_logout' %}" class="account-link">Se d&eacute;connecter</a>
             {% else %}
             <span class="register">\1{% url 'auth_login' %}"\3</span>
             {% endif %}
           {% end_skeleton_extra_placeholder %}''', content)

open('theme.html', 'w').write(content)
